Index: backend/access/transam/xlog.c
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/backend/access/transam/xlog.c,v
retrieving revision 1.149
diff -d -c -r1.149 xlog.c
*** backend/access/transam/xlog.c	19 Jul 2004 14:34:39 -0000	1.149
--- backend/access/transam/xlog.c	20 Jul 2004 14:03:12 -0000
***************
*** 2370,2376 ****
  	 * Currently, xl_len == 0 must be bad data, but that might not be true
  	 * forever.  See note in XLogInsert.
  	 */
! 	if (record->xl_len == 0)
  	{
  		ereport(emode,
  				(errmsg("record with zero length at %X/%X",
--- 2370,2380 ----
  	 * Currently, xl_len == 0 must be bad data, but that might not be true
  	 * forever.  See note in XLogInsert.
  	 */
! 	if (record->xl_len == 0 && record->xl_info != XLOG_WASTED_SPACE)
  	{
  		ereport(emode,
  				(errmsg("record with zero length at %X/%X",
***************
*** 2489,2495 ****
  	}
  
  	/* Record does not cross a page boundary */
! 	if (!RecordIsValid(record, *RecPtr, emode))
  		goto next_record_is_invalid;
  	if (BLCKSZ - SizeOfXLogRecord >= RecPtr->xrecoff % BLCKSZ +
  		MAXALIGN(total_len))
--- 2493,2499 ----
  	}
  
  	/* Record does not cross a page boundary */
! 	if (!RecordIsValid(record, *RecPtr, emode) && record->xl_info != XLOG_WASTED_SPACE)
  		goto next_record_is_invalid;
  	if (BLCKSZ - SizeOfXLogRecord >= RecPtr->xrecoff % BLCKSZ +
  		MAXALIGN(total_len))
